/* Copyright 2013 Neil Edelman, distributed under the terms of the
 GNU General Public License, see copying.txt */

/* OpenGL not-on-a-mac is a little harder since OpenGL > 1.0 functions have to
 be quiried from the library in a platform-specific way; I use glew to make it
 easier; this file shall not be included on a Mac */

#include <stdio.h>  /* fprintf */
#include "Glew.h"

/* public */

/** constructor */
int Glew(void) {
	GLenum err;
	if((err = glewInit()) != GLEW_OK) {
		fprintf(stderr, "Glew: %s\n", glewGetErrorString(err));
		return 0;
	}
	if(!glewIsSupported("GL_VERSION_2_0") /* !GLEW_VERSION_2_0 ? */) {
		printf("Glew: OpenGL 2.0 shadows are not supported.\n");
		return 0;
	}
	fprintf(stdout, "Glew: GLEW %s extension loading library loaded extensions.\n", glewGetString(GLEW_VERSION));

	/* FIXME: check for VBOs */
	return -1;
}
