struct Open;

/* polluting the namespace! but really, these are ubiquitous */
struct Vec2f { float x, y; };
struct Vec2i { int x, y; };
struct Colour3f { float r, g, b; };
struct Colour4f { float r, g, b, a; };

/* VS maybe not/maybe defines this, so define our own and then some */
#undef M_SQRT1_2
#undef M_PI
#define M_SQRT1_2 (0.707106781186547524400844362104849039284835937688474036588339) /* 1/Sqrt[2] */
#define M_PI (3.141592653589793238462643383279502884197169399375105820974944) /* Pi */
#define M_2PI (6.283185307179586476925286766559005768394338798750211641949889) /* 2Pi */
#define M_1_2PI (0.159154943091895335768883763372514362034459645740456448747667) /* 1/(2Pi) */
#define M_180_PI (57.29577951308232087679815481410517033240547246656432154916024) /* 180 / pi */

/* https://en.wikipedia.org/wiki/Keyboard_layout
 101 key US, 104 key Windows, 102/105 international, 110/109/112 extended
 so there's lots of room for these */
enum Keys {
	k_unknown = 0,
	k_f1 = 255 - 21,
	k_f2,
	k_f3,
	k_f4,
	k_f5,
	k_f6,
	k_f7,
	k_f8,
	k_f9,
	k_f10,
	k_f11,
	k_f12,
	k_left,
	k_up,
	k_right,
	k_down,
	k_pgup,
	k_pgdn,
	k_home,
	k_end,
	k_ins,
	k_max
};

struct Open *Open(const int width, const int height, const char *title);
void Open_(void);
void OpenPrint(const char *fmt, ...);
void OpenToggleFullScreen(void);
int OpenTexture(const int width, const int height, const int depth, const unsigned char *bmp);
void OpenTexture_(int name);

int OpenKeyTime(const int key);
int OpenKeyPress(const int key);

const struct Vec2f *OpenGetScreen(void);
