static const char *shader_vs =
"/* 1.10 default */\n"
"#define MAX_LIGHTS 64\n"
"\n"
"void main() {\n"
"	/* translation + rotation */\n"
"	/* fixme: 'GLSL common mistakes' says I should not do this? but why and how? */\n"
"	gl_TexCoord[0].st = gl_MultiTexCoord0.st;\n"
"	/* translation + rotation - rotation (specified by TextureMatrix) */\n"
"	/* fixme: without the shader, every sprite is at 0 rotation :[ */\n"
"	gl_TexCoord[1] = gl_TextureMatrix[0] * gl_MultiTexCoord0;\n"
"	gl_Position = ftransform();\n"
"}\n"
"";
static const char *shader_fs =
"/* 1.10 defualt */\n"
"#define M_PI 3.1415926535897932384626433832795 /* pi */\n"
"#define M_1_PI 0.318309886183790671537767526745028724 /* 1/pi */\n"
"#define M_2_PI 0.636619772367581343075535053490057448 /* 2/pi */\n"
"#define M_2PI 6.283185307179586476925286766559005768394338798750211641949889 /* 2pi */\n"
"#define M_1_2PI 0.159154943091895335768883763372514362034459645740456448747667 /* 1/(2pi) */\n"
"\n"
"#define MAX_LIGHTS 64\n"
"#define AMBIENT 0.08\n"
"\n"
"uniform sampler2D sprite;\n"
"uniform sampler2D lighting;\n"
"uniform int  l_no;\n"
"/* fixme: is this too much to be passing as a uniform? other methods don't work in 1.10 */\n"
"uniform vec3 l_lux[MAX_LIGHTS];\n"
"uniform vec2 l_pos[MAX_LIGHTS];\n"
"\n"
"void main() {\n"
"	vec4 texel = texture2D(sprite, gl_TexCoord[0].st);\n"
"	/* light.r = f(radius) [0-1); light.g = angle [0-1)\n"
"	(GL_RG32F is un-normalised, but it's clamping my textures, possibly GL_LINEAR?) */\n"
"	vec4 light  = texture2D(lighting, gl_TexCoord[1].st);\n"
"	/* light colour, start ambient */\n"
"	vec3 shade = vec3(AMBIENT);\n"
"	for(int i = 0; i < MAX_LIGHTS; i++) {\n"
"		if(i < l_no) {\n"
"			/* the relative location of the light */\n"
"			vec2 relative = l_pos[i] - gl_ModelViewMatrix[3].xy;\n"
"			float dist = length(relative) + 0.1;//d_to_l[i];\n"
"			/* the angle to the light, in the sprite, and the difference */\n"
"			/* fixme: annoying singularity when light passes from 1 - 0 */\n"
"			float tolight = atan(relative.y, relative.x);//a_to_l[i];\n"
"			float insprite = light.g * M_2PI;\n"
"			float delta = abs(mod(insprite - tolight + M_PI, M_2PI) - M_PI);\n"
"			/* the final contrubution from light i */\n"
"			shade += l_lux[i] * mix(1.0, M_PI - delta, light.r) / dist;\n"
"		} else {\n"
"			break;\n"
"		}\n"
"	}\n"
"	gl_FragColor = vec4(shade, 1.0) * texel;\n"
"}\n"
"";
